package com.hotwj.platform.config.course.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hotwj.platform.config.course.domain.HotCourse;
import com.hotwj.platform.config.course.domain.bo.HotCourseBo;
import com.hotwj.platform.config.course.domain.vo.HotCourseVo;
import com.hotwj.platform.config.course.mapper.HotCourseMapper;
import com.hotwj.platform.config.course.service.IHotCourseService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 课程库Service业务层处理
 *
 * @author shihongwei
 * @date 2025-12-23
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class HotCourseServiceImpl implements IHotCourseService {

    private final HotCourseMapper baseMapper;

    /**
     * 查询课程库
     *
     * @param id 主键
     * @return 课程库
     */
    @Override
    public HotCourseVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询课程库列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 课程库分页列表
     */
    @Override
    public TableDataInfo<HotCourseVo> queryPageList(HotCourseBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<HotCourse> lqw = buildQueryWrapper(bo);
        Page<HotCourseVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的课程库列表
     *
     * @param bo 查询条件
     * @return 课程库列表
     */
    @Override
    public List<HotCourseVo> queryList(HotCourseBo bo) {
        LambdaQueryWrapper<HotCourse> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<HotCourse> buildQueryWrapper(HotCourseBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<HotCourse> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(HotCourse::getId);
        lqw.eq(bo.getCompanyId() != null, HotCourse::getCompanyId, bo.getCompanyId());
        lqw.like(StringUtils.isNotBlank(bo.getName()), HotCourse::getName, bo.getName());
        lqw.eq(StringUtils.isNotBlank(bo.getTrainingTypeCode()), HotCourse::getTrainingTypeCode, bo.getTrainingTypeCode());
        lqw.eq(StringUtils.isNotBlank(bo.getTrainingSubtypeCodes()), HotCourse::getTrainingSubtypeCodes, bo.getTrainingSubtypeCodes());
        lqw.eq(StringUtils.isNotBlank(bo.getDescription()), HotCourse::getDescription, bo.getDescription());
        lqw.eq(StringUtils.isNotBlank(bo.getCoverUrl()), HotCourse::getCoverUrl, bo.getCoverUrl());
        lqw.eq(StringUtils.isNotBlank(bo.getMaterialUrl()), HotCourse::getMaterialUrl, bo.getMaterialUrl());
        lqw.eq(bo.getLearningDuration() != null, HotCourse::getLearningDuration, bo.getLearningDuration());
        lqw.eq(bo.getClassHours() != null, HotCourse::getClassHours, bo.getClassHours());
        lqw.eq(StringUtils.isNotBlank(bo.getContent()), HotCourse::getContent, bo.getContent());
        lqw.eq(bo.getStatus() != null, HotCourse::getStatus, bo.getStatus());
        lqw.eq(bo.getIsDeleted() != null, HotCourse::getIsDeleted, bo.getIsDeleted());
        lqw.between(params.get("beginTime") != null && params.get("endTime") != null,
                HotCourse::getCreateTime, params.get("beginTime"), params.get("endTime"));
        return lqw;
    }

    /**
     * 新增课程库
     *
     * @param bo 课程库
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(HotCourseBo bo) {
        HotCourse add = MapstructUtils.convert(bo, HotCourse.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改课程库
     *
     * @param bo 课程库
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(HotCourseBo bo) {
        HotCourse update = MapstructUtils.convert(bo, HotCourse.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(HotCourse entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除课程库信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
